#include <p30fxxxx.h>
#include "defs.h"
#include "port.h"

void port_init(void)
{

    bus_wr_hi();                                           // Set /RD and /WR to high
    bus_rd_hi();

    BUS_WR_TRIS &= ~BUS_WR_MASK;                           // Configure /RD and /WR as outputs
    BUS_RD_TRIS &= ~BUS_RD_MASK;

    BUS_ADDR_TRIS &= ~BUS_ADDR_MASK;                       // Configure address bus to output
}

void port_write(uint16_t addr, uint16_t data)
{

    bus_addr(addr);
    BUS_DATA_LATCH = (BUS_DATA_LATCH & ~BUS_DATA_MASK) | (data & 0xFF);
    bus_data_out();

    nop();
    bus_wr_lo();
    nop();
    nop();
    bus_wr_hi();
}

uint8_t port_read(uint16_t addr)
{
    uint16_t data;

    bus_addr(addr);
    bus_data_in();

    bus_rd_lo();
    nop();
    nop();
    data = BUS_DATA_PIN & BUS_DATA_MASK;
    bus_rd_hi();
    return (uint8_t) data;
}
